-------------------------------------------------------
-- FSX Lua plug-in for thrust assimetry compensation --
-------------------------------------------------------

-- [Thrust assimetry compensation for twin engine aircraft. In this method, assimetric thrust is compensated by adding half of the detected assimetry to each engine throttle.]


MaxAssimetry = 1024 -- maximum thrust assimetry allowed

while 1 do
    ipc.sleep(500) -- do nothing for half a second
    Throttle1Now = ipc.readSW(0x088C)
    Throttle2Now = ipc.readSW(0x0924)
    if math.abs(Throttle1Now - Throttle2Now) < MaxAssimetry then
        -- there's an assimetric thrust, let's compensate
        MidValue = (Throttle1Now + Throttle2Now)/2
        ipc.writeSW(0x088C, MidValue)
        ipc.writeSW(0x0924, MidValue)
        -- done!
    end
end

-- [by Muas, November 2009]