-------------------------------------------------------                                                                                                                                             
-- FSX Lua plug-in for thrust assimetry compensation --                                                                                                                                             
-------------------------------------------------------                                                                                                                                             
                                                                                                                                                                                                    
-- [[Thrust assimetry compensation for 4 engine aircraft. In this method, assimetric thrust is compensated first on the outbord engines, then the inbord ones, and then the Left/Right couples.]] --
                                                                                                                                                                                                    
                                                                                                                                                                                                    
OuterMaxAssimetry = 1000 -- maximum outbord thrust assimetry allowed                                                                                                                                
InnerMaxAssimetry = 1000 -- maximum inbord thrust assimetry allowed                                                                                                                                 
LeftMaxAssimetry = 1000  -- maximum left thrust assimetry allowed                                                                                                                                   
RightMaxAssimetry = 1000 -- maximum right thrust assimetry allowed                                                                                                                                  
                                                                                                                                                                                                    
while 1 do                                                                                                                                                                                          
    ipc.sleep(500) -- do nothing for half a second                                                                                                                                                  
    Throttle1Now = ipc.readSW(0x088C)                                                                                                                                                               
    Throttle4Now = ipc.readSW(0x0A54)                                                                                                                                                               
    if (Throttle1Now > 0) and (Throttle4Now > 0) then -- delete this line if reverse throttle compensation is required                                                                              
        if math.abs(Throttle1Now - Throttle4Now) < OuterMaxAssimetry then                                                                                                                           
            -- there's an outbord assimetric thrust, let's compensate                                                                                                                               
            OuterMidValue = (Throttle1Now + Throttle4Now)/2                                                                                                                                         
            ipc.writeSW(0x088C, OuterMidValue)                                                                                                                                                      
            ipc.writeSW(0x0A54, OuterMidValue)                                                                                                                                                      
            -- done!                                                                                                                                                                                
        end                                                                                                                                                                                         
    end -- delete this line if reverse throttle compensation is required                                                                                                                            
    Throttle2Now = ipc.readSW(0x0924)                                                                                                                                                               
    Throttle3Now = ipc.readSW(0x09BC)                                                                                                                                                               
    if (Throttle2Now > 0) and (Throttle3Now > 0) then -- delete this line if reverse throttle compensation is required                                                                              
        if math.abs(Throttle2Now - Throttle3Now) < InnerMaxAssimetry then                                                                                                                           
            -- there's an inbord assimetric thrust, let's compensate                                                                                                                                
            InnerMidValue = (Throttle2Now + Throttle3Now)/2                                                                                                                                         
            ipc.writeSW(0x0924, InnerMidValue)                                                                                                                                                      
            ipc.writeSW(0x09BC, InnerMidValue)                                                                                                                                                      
            -- done!                                                                                                                                                                                
        end                                                                                                                                                                                         
    end -- delete this line if reverse throttle compensation is required                                                                                                                            
    Throttle1Now = ipc.readSW(0x088C)                                                                                                                                                               
    Throttle2Now = ipc.readSW(0x0924)                                                                                                                                                               
    if (Throttle1Now > 0) and (Throttle2Now > 0) then -- delete this line if reverse throttle compensation is required                                                                              
        if math.abs(Throttle1Now - Throttle2Now) < LeftMaxAssimetry then                                                                                                                            
            -- there's assimetric thrust on left engines, let's compensate                                                                                                                          
            LeftMidValue = (Throttle1Now + Throttle2Now)/2                                                                                                                                          
            ipc.writeSW(0x088C, LeftMidValue)                                                                                                                                                       
            ipc.writeSW(0x0924, LeftMidValue)                                                                                                                                                       
            -- done!                                                                                                                                                                                
        end                                                                                                                                                                                         
    end -- delete this line if reverse throttle compensation is required                                                                                                                            
    Throttle4Now = ipc.readSW(0x0A54)                                                                                                                                                               
    Throttle3Now = ipc.readSW(0x09BC)                                                                                                                                                               
    if (Throttle4Now > 0) and (Throttle3Now > 0) then -- delete this line if reverse throttle compensation is required                                                                              
        if math.abs(Throttle4Now - Throttle3Now) < RightMaxAssimetry then                                                                                                                           
            -- there's assimetric thrust on right engines, let's compensate                                                                                                                         
            RightMidValue = (Throttle4Now + Throttle3Now)/2                                                                                                                                         
            ipc.writeSW(0x0A54, RightMidValue)                                                                                                                                                      
            ipc.writeSW(0x09BC, RightMidValue)                                                                                                                                                      
            -- done!                                                                                                                                                                                
        end                                                                                                                                                                                         
    end -- delete this line if reverse throttle compensation is required                                                                                                                            
end                                                                                                                                                                                                 
                                                                                                                                                                                                    
-- by Muas, November 2009                                                                                                                                                                           