-- handles first two WP6's only
displaymax = 20

-- clear down the display
ipc.lineDisplay("", 0)

local function BrightTest()
   -- Brightness test max->min
   for br = 15, 0, -1 do
      gfd.SetBright(GFWP6,0,br)
      gfd.SetBright(GFWP6,1,br)
      ipc.sleep(50)
   end

   -- Brightness test min->max
   for br = 0, 15 do
      gfd.SetBright(GFWP6,0,br)
      gfd.SetBright(GFWP6,1,br)
      ipc.sleep(50)
   end
end

-- Set all white colour = 1)
ipc.lineDisplay("All indicators WHITE", -displaymax)
ipc.log("All indicators WHITE")
for ind = 0, 5 do
  gfd.SetColour(GFWP6,0,ind,1)
  gfd.SetColour(GFWP6,1,ind,1)
end

-- set all on
ipc.lineDisplay("All indicators ON", -displaymax)
ipc.log("All indicators ON")
gfd.SetLights(GFWP6,0,0x3f,0)
gfd.SetLights(GFWP6,1,0x3f,0)
ipc.sleep(1000)

-- Brightness test
ipc.lineDisplay("Brightness down then up", -displaymax)
ipc.log("Brightness down then up")
BrightTest()

-- Off for 1 sec
ipc.lineDisplay("All off for 1 sec", -displaymax)
ipc.log("All off for 1 sec")
gfd.SetLights(GFWP6,0,0,0x3f)
gfd.SetLights(GFWP6,1,0,0x3f)
ipc.sleep(1000)

-- Colour rotation
ipc.lineDisplay("Preset colour rotation", -displaymax)
ipc.log("Preset colour rotation")
col = 1
ind = 0
dev = 0
for n = 0, 500 do
   gfd.SetColour(GFWP6,dev, ind, col)
   col = col + 1
   if col > 7 then col = 1 end
   ind = ind + 1
   if ind > 5 then
   		ind = 0
	    gfd.SetLights(GFWP6,dev,0x3f,0)
   		dev = 1 - dev
      ipc.sleep(10)
   end
end

-- Off for 1 sec
ipc.lineDisplay("All off for 1 sec", -displaymax)
ipc.log("All off for 1 sec")
gfd.SetLights(GFWP6,0,0,0x3f)
gfd.SetLights(GFWP6,1,0,0x3f)
ipc.sleep(1000)

-- RGB mode, random colour test
ipc.lineDisplay("Random RGB colours with brighness changes", -displaymax)
ipc.log("Random RGB colours with brighness changes")
math.randomseed(ipc.elapsedtime())
ind = 0
dev = 0
for n = 0, 500 do
	 R = math.floor(math.random(1,100))
	 G = math.floor(math.random(1,100))
	 B = math.floor(math.random(1,100))
	 gfd.SetColour(GFWP6,dev, ind, R, G, B)
   ind = ind + 1
   if ind > 5 then
   		ind = 0
      gfd.SetLights(GFWP6,dev,0x3f,0)
   		dev = 1 - dev
   		if dev == 0 then 
	       ipc.sleep(10)
	    end
   end
end

-- RGB brightness test
ipc.sleep(1000)
ipc.lineDisplay("Brightness down then up", -displaymax)
ipc.log("Brightness down then up")
BrightTest()

ipc.lineDisplay("Test completed: all off", -displaymax)
gfd.SetLights(GFWP6,0,0,0x3f)
gfd.SetLights(GFWP6,1,0,0x3f)
ipc.sleep(5000)




