-- "Display Vals" example LUA plug-in, by Pete Dowson, September 2008

-- Loop forever: to stop this you'll have to use the LuaKill control on it.
while 1 do

-- Get all of the data we want to display
gs, tas, ias = ipc.readStruct(0x02B4, "3UD")
lat, lon, alt, pitch, bank, hdgT = ipc.readStruct(0x0560,"3DD", "2SD", "1UD")
mach = ipc.readUW(0x11C6)
vs = ipc.readSW(0x842)

-- and convert it from FS units to units we like
gs = (gs * 3600) / (65536 * 1852)
tas = tas / 128
ias = ias / 128
mach = mach / 20480
vs = vs * -3.28084

lat = lat * 90 / (10001750 * 65536 * 65536)
lon = lon * 360 /  (65536 * 65536 * 65536 * 65536)
alt = alt * 3.28084 / (65536 * 65536)
pitch = pitch * 360 / (65536 * 65536)
bank = bank * 360 / (65536 * 65536)
hdgM = hdgT - (ipc.readSW(0x02A0) * 65536)
hdgM = hdgM * 360 / (65536 * 65536)
hdgT = hdgT * 360 / (65536 * 65536)

-- display it all in an FS window
-- (note, there is a limit of 1023 characters in this, but we fit okay)
ipc.display("lat="..lat.."\nlon="..lon.."\nalt="..alt.."\npitch="..pitch.."\
bank="..bank.."\nhdgT="..hdgT.."\nhdgM="..hdgM.."\
vs="..vs.."\nias="..ias.."\ntas="..tas.."\ngs="..gs.."\nmach="..mach)

-- Note the use of the \ escape to allow us to use multiple lines in a single string
-- The \n and the \ followed by a real new line both get included as new lines in the result

-- Sleep for 50 mSecs so the update gets done roughly 20 times per second
ipc.sleep(50)

end
