-- "Init Pos" example LUA plug-in, by Pete Dowson, September 2008

-- This simply initialises the aircraft position according to set parameters.
-- In a real application you'd get these from a file or another program
ias = 210
ongnd = 0
lat = 50.0
lon = -1.0
alt = 5000
pitch = -2
bank = 15
hdgM = 340

-- we need to convert some of these to FS units
hdgT = (((hdgM * 65536) / 360) + ipc.readSW(0x02A0)) * 65536
lat = (lat / 90) * (10001750 * 65536 * 65536)
lon = (lon / 360) *  (65536 * 65536 * 65536 * 65536)
alt = (alt / 3.28084) * (65536 * 65536)
pitch = (pitch / 360) * (65536 * 65536)
bank = (bank / 360) * (65536 * 65536)

-- now write it all in one structure write -- this instigates the SimConnect "InitPosition" action
ipc.writeStruct(0x0558,"2UD", ias, ongnd,"3DD", lat, lon, alt, "2SD", pitch, bank, "1UD", hdgT)

