-- mrudder.lua: Mouse controlled rudder facility

-- Assign a button or keypress to "LuaToggle mrudder"
-- Use that button to toggle this action on or off

-- When it is On, hold right-mouse button down and move mouse
-- side to side to position the rudder

mousex, mousey = 0, 0 --for saving user mouse position

function trackmouse(x, y)
   -- actual rudder movement for changes in x position
   ipc.writeSW(0x0BBA, (x - 50) * 327.68)
end

function operaterudder(x, y, mov, flags)
   if logic.And(flags, 2) ~= 0 then
      -- right button is down
   
      -- save mouse position
      mousex, mousey = x, y;
	    
      -- set position to rudder position
      x = 50 + (ipc.readSW(0x0BBC) / 327.68)
      mouse.move(x, 50, 2)
      
      event.mousemove(2, "trackmouse")
   else
      -- right button is up    
      event.cancel("trackmouse")
      
      -- restore mouse position
      mouse.move(mousex, mousey, 2)
   end
end

function toggleaction(flag)
  if ipc.testflag(flag) then
     -- action is enabled: trap right mouse button
     event.mouserighttrap(2, "operaterudder")
  else
  	 event.cancel("operaterudder")
  end
end

event.flag("toggleaction")
